<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>print() for C++20: include/terminalcolors.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">print() for C++20
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">terminalcolors.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="terminalcolors_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (c) 2021 Martin B. Krauss.</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// Licensed under the MIT LICENSE.</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// See the file &#39;LICENSE&#39; that should be distributed with this software or can</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// be found at &#39;https://gitlab.com/martin.b.krauss/cpp20-print&#39; for details.</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef CPP20PRINT_TERMINALCOLORS_H</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define CPP20PRINT_TERMINALCOLORS_H</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="keyword">namespace </span>cpp20print::terminal {</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="terminalcolors_8h.html#ab87bacfdad76e61b9412d7124be44c1c">   20</a></span>&#160;<span class="keyword">enum class</span> <a class="code" href="terminalcolors_8h.html#ab87bacfdad76e61b9412d7124be44c1c">Color</a> {</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    System,</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    Red,</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    Green,</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    Blue,</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    Yellow,</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    Magenta,</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    Cyan,</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    White,</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    Error = Red,</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    Warning = Yellow,</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    Fail = Magenta,</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    Notification = Blue,</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    Emphasis = Cyan,</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    Success = Green,</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    Default = System    </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;};</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="terminalcolors_8h.html#add354b854a8899ddb39fc9d57bbe22e3">   39</a></span>&#160;<span class="keyword">enum class</span> <a class="code" href="terminalcolors_8h.html#add354b854a8899ddb39fc9d57bbe22e3">Weight</a> {</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    Normal,</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    Bold,</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    Default = Normal</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;};</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="structcpp20print_1_1terminal_1_1TerminalColor.html">   47</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structcpp20print_1_1terminal_1_1TerminalColor.html">TerminalColor</a> {</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string Reset       ;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string Black       ;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string Red         ;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string Green       ;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string Yellow      ;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string Blue        ;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string Magenta     ;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string Cyan        ;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string White       ;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string BoldBlack   ;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string BoldRed     ;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string BoldGreen   ;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string BoldYellow  ;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string BoldBlue    ;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string BoldMagenta ;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string BoldCyan    ;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keyword">const</span> <span class="keyword">static</span> std::string BoldWhite   ;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">static</span> std::string <a class="code" href="structcpp20print_1_1terminal_1_1TerminalColor.html#a2de0630653b342ad1be13e8cb5642c85">get</a>(<span class="keyword">const</span> <a class="code" href="terminalcolors_8h.html#ab87bacfdad76e61b9412d7124be44c1c">Color</a>, <span class="keyword">const</span> <a class="code" href="terminalcolors_8h.html#add354b854a8899ddb39fc9d57bbe22e3">Weight</a> = Weight::Default);</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;};</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno"><a class="line" href="classcpp20print_1_1terminal_1_1StreamModifier.html">   82</a></span>&#160;<span class="keyword">class </span><a class="code" href="classcpp20print_1_1terminal_1_1StreamModifier.html">StreamModifier</a> {</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="classcpp20print_1_1terminal_1_1StreamModifier.html#ad40734bf045f1fc3da4b4e6712ef5635">   87</a></span>&#160;        <a class="code" href="classcpp20print_1_1terminal_1_1StreamModifier.html#ad40734bf045f1fc3da4b4e6712ef5635">StreamModifier</a> (std::ostream&amp; stream) :</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            stream_ {stream},</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;            flags_ {stream.flags()}</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        { }</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160; </div>
<div class="line"><a name="l00096"></a><span class="lineno"><a class="line" href="classcpp20print_1_1terminal_1_1StreamModifier.html#a4fda381c4f568351b550f67d3443592c">   96</a></span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classcpp20print_1_1terminal_1_1StreamModifier.html#a4fda381c4f568351b550f67d3443592c">set_color</a>(</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;                <span class="keyword">const</span> <a class="code" href="terminalcolors_8h.html#ab87bacfdad76e61b9412d7124be44c1c">Color</a> color, </div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;                <span class="keyword">const</span> <a class="code" href="terminalcolors_8h.html#add354b854a8899ddb39fc9d57bbe22e3">Weight</a> weight = Weight::Default</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;                ) </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        {</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            <span class="comment">// Use escape sequences only for terminal output (not file)</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            <span class="keywordflow">if</span> (&amp;stream_ == &amp;std::cout || &amp;stream_ == &amp;std::cerr) {</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;                stream_ &lt;&lt; <a class="code" href="structcpp20print_1_1terminal_1_1TerminalColor.html#a2de0630653b342ad1be13e8cb5642c85">TerminalColor::get</a>(color, weight);</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;            }</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        }</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160; </div>
<div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="classcpp20print_1_1terminal_1_1StreamModifier.html#a69483bca44104d0bcd0b2270ad2549ab">  108</a></span>&#160;        <a class="code" href="classcpp20print_1_1terminal_1_1StreamModifier.html#a69483bca44104d0bcd0b2270ad2549ab">~StreamModifier</a>() noexcept {</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;            <span class="comment">// Use escape sequences only for terminal output (not file)</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            <span class="keywordflow">if</span> (&amp;stream_ == &amp;std::cout || &amp;stream_ == &amp;std::cerr) {</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;                stream_ &lt;&lt; TerminalColor::Reset &lt;&lt; std::flush;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;            }</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;            stream_.flags(flags_);</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        }</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160; </div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="keyword">private</span>:</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        std::ostream&amp; stream_;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        std::ios_base::fmtflags flags_;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;};</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160; </div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;}</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160; </div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="preprocessor">#endif</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="astructcpp20print_1_1terminal_1_1TerminalColor_html"><div class="ttname"><a href="structcpp20print_1_1terminal_1_1TerminalColor.html">cpp20print::terminal::TerminalColor</a></div><div class="ttdoc">Defines constants for terminal escape sequences, which can be used to format color and weight of term...</div><div class="ttdef"><b>Definition:</b> terminalcolors.h:47</div></div>
<div class="ttc" id="aclasscpp20print_1_1terminal_1_1StreamModifier_html_a4fda381c4f568351b550f67d3443592c"><div class="ttname"><a href="classcpp20print_1_1terminal_1_1StreamModifier.html#a4fda381c4f568351b550f67d3443592c">cpp20print::terminal::StreamModifier::set_color</a></div><div class="ttdeci">void set_color(const Color color, const Weight weight=Weight::Default)</div><div class="ttdoc">Set the output color and font weight for the associated stream.</div><div class="ttdef"><b>Definition:</b> terminalcolors.h:96</div></div>
<div class="ttc" id="aterminalcolors_8h_html_add354b854a8899ddb39fc9d57bbe22e3"><div class="ttname"><a href="terminalcolors_8h.html#add354b854a8899ddb39fc9d57bbe22e3">cpp20print::terminal::Weight</a></div><div class="ttdeci">Weight</div><div class="ttdoc">Defines values to select a font weight for printing to a terminal.</div><div class="ttdef"><b>Definition:</b> terminalcolors.h:39</div></div>
<div class="ttc" id="aclasscpp20print_1_1terminal_1_1StreamModifier_html"><div class="ttname"><a href="classcpp20print_1_1terminal_1_1StreamModifier.html">cpp20print::terminal::StreamModifier</a></div><div class="ttdoc">Helper class that keeps track of stream flags.</div><div class="ttdef"><b>Definition:</b> terminalcolors.h:82</div></div>
<div class="ttc" id="aterminalcolors_8h_html_ab87bacfdad76e61b9412d7124be44c1c"><div class="ttname"><a href="terminalcolors_8h.html#ab87bacfdad76e61b9412d7124be44c1c">cpp20print::terminal::Color</a></div><div class="ttdeci">Color</div><div class="ttdoc">Defines values to select colors for printing to a terminal.</div><div class="ttdef"><b>Definition:</b> terminalcolors.h:20</div></div>
<div class="ttc" id="aclasscpp20print_1_1terminal_1_1StreamModifier_html_ad40734bf045f1fc3da4b4e6712ef5635"><div class="ttname"><a href="classcpp20print_1_1terminal_1_1StreamModifier.html#ad40734bf045f1fc3da4b4e6712ef5635">cpp20print::terminal::StreamModifier::StreamModifier</a></div><div class="ttdeci">StreamModifier(std::ostream &amp;stream)</div><div class="ttdoc">Initializes class and saves current flags of the stream.</div><div class="ttdef"><b>Definition:</b> terminalcolors.h:87</div></div>
<div class="ttc" id="aclasscpp20print_1_1terminal_1_1StreamModifier_html_a69483bca44104d0bcd0b2270ad2549ab"><div class="ttname"><a href="classcpp20print_1_1terminal_1_1StreamModifier.html#a69483bca44104d0bcd0b2270ad2549ab">cpp20print::terminal::StreamModifier::~StreamModifier</a></div><div class="ttdeci">~StreamModifier() noexcept</div><div class="ttdoc">Resets the flags and output color of the stream.</div><div class="ttdef"><b>Definition:</b> terminalcolors.h:108</div></div>
<div class="ttc" id="astructcpp20print_1_1terminal_1_1TerminalColor_html_a2de0630653b342ad1be13e8cb5642c85"><div class="ttname"><a href="structcpp20print_1_1terminal_1_1TerminalColor.html#a2de0630653b342ad1be13e8cb5642c85">cpp20print::terminal::TerminalColor::get</a></div><div class="ttdeci">static std::string get(const Color, const Weight=Weight::Default)</div><div class="ttdoc">Get an escape sequence encoding a color and weight for formatting terminal output.</div><div class="ttdef"><b>Definition:</b> terminal.cpp:52</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
